/*
 * File Name: persistent_mem_errors.h
 * File Path: /emmate/src/persistent/persistent_mem_errors.h
 * Description:
 *
 *  Created on: 15-Apr-2019
 *      Author: Rohan Dey
 */

#ifndef PERSISTENT_MEM_ERRORS_H_
#define PERSISTENT_MEM_ERRORS_H_

#include "core_config.h"

#if CONFIG_USE_NVS
#include "nvs_helper_errors.h"

/* ERROR CODES RELATED TO NVS MEMORY */
#define CORE_ERR_NVS_BASE				PLAT_ERR_NVS_BASE
#define CORE_ERR_NVS_NOT_INITIALIZED	PLAT_ERR_NVS_NOT_INITIALIZED
#define CORE_ERR_NVS_NOT_FOUND			PLAT_ERR_NVS_NOT_FOUND
#define CORE_ERR_NVS_TYPE_MISMATCH		PLAT_ERR_NVS_TYPE_MISMATCH
#define CORE_ERR_NVS_READ_ONLY			PLAT_ERR_NVS_READ_ONLY
#define CORE_ERR_NVS_NOT_ENOUGH_SPACE	PLAT_ERR_NVS_NOT_ENOUGH_SPACE
#define CORE_ERR_NVS_INVALID_NAME		PLAT_ERR_NVS_INVALID_NAME
#define CORE_ERR_NVS_INVALID_HANDLE		PLAT_ERR_NVS_INVALID_HANDLE
#define CORE_ERR_NVS_REMOVE_FAILED		PLAT_ERR_NVS_REMOVE_FAILED
#define CORE_ERR_NVS_KEY_TOO_LONG		PLAT_ERR_NVS_KEY_TOO_LONG
#define CORE_ERR_NVS_PAGE_FULL			PLAT_ERR_NVS_PAGE_FULL
#define CORE_ERR_NVS_INVALID_STATE		PLAT_ERR_NVS_INVALID_STATE
#define CORE_ERR_NVS_INVALID_LENGTH		PLAT_ERR_NVS_INVALID_LENGTH
#define CORE_ERR_NVS_NO_FREE_PAGES		PLAT_ERR_NVS_NO_FREE_PAGES
#define CORE_ERR_NVS_VALUE_TOO_LONG		PLAT_ERR_NVS_VALUE_TOO_LONG
#define CORE_ERR_NVS_PART_NOT_FOUND		PLAT_ERR_NVS_PART_NOT_FOUND

#define CORE_ERR_NVS_NEW_VERSION_FOUND		PLAT_ERR_NVS_NEW_VERSION_FOUND
#define CORE_ERR_NVS_XTS_ENCR_FAILED		PLAT_ERR_NVS_XTS_ENCR_FAILED
#define CORE_ERR_NVS_XTS_DECR_FAILED		PLAT_ERR_NVS_XTS_DECR_FAILED
#define CORE_ERR_NVS_XTS_CFG_FAILED			PLAT_ERR_NVS_XTS_CFG_FAILED
#define CORE_ERR_NVS_XTS_CFG_NOT_FOUND		PLAT_ERR_NVS_XTS_CFG_NOT_FOUND
#define CORE_ERR_NVS_ENCR_NOT_SUPPORTED		PLAT_ERR_NVS_ENCR_NOT_SUPPORTED
#define CORE_ERR_NVS_KEYS_NOT_INITIALIZED	PLAT_ERR_NVS_KEYS_NOT_INITIALIZED
#define CORE_ERR_NVS_CORRUPT_KEY_PART		PLAT_ERR_NVS_CORRUPT_KEY_PART
#endif

#endif /* PERSISTENT_MEM_ERRORS_H_ */
